#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * This program is an improvement on the getinfo program from last lecture
 *
 * In this version, we check to see if the user entered too many characters
 * for a name.  If so, we truncate whatever they entered before copying
 *
 * In order to test this program, getinfo.h has been changed to have a
 * fairly small size for NAMESIZ.  It is currently set to 10
 *
 * Type in a short and a long name and see what happens
 *
 */

/* we use our own include file here, which defines NAMESIZ */
#include "getinfo.h"

main()
{
    char buf[BUFSIZ]; /* input area for user */
    char fname[NAMESIZ], lname[NAMESIZ]; /* storage area for first and last name */
    int age; /* variable for age */

    printf("Enter first name: "); /* ask for their first name */
    gets(buf); /* read response */
    if (strlen(buf) >= NAMESIZ)
    { /* name too long - will clobber memory if we copy it like this */
        printf("Name too long, must be less than %d characters\n", NAMESIZ);
        /* truncate whatever the user entered */
        buf[NAMESIZ-1] = '\0'; /* chop off last part of name */
    }
    strcpy(fname, buf);     /* save first name */

    printf("Enter last name: "); /* ask for their last name */
    gets(buf); /* read response from user */
    if (strlen(buf) >= NAMESIZ)
    {
        printf("Name too long, must be less than %d characters\n", NAMESIZ);
        /* truncate whatever the user entered */
        buf[NAMESIZ-1] = '\0'; /* chop off last part of name */
    }

    /* 
     * here is another way to handle a string too long
     * instead of truncating what was entered, don't copy anything
     *
     * This will result in an empty field, so there should be
     * a way for the user to enter it later.
     */
    if (strlen(buf) < NAMESIZ)
    { /* room to copy name */
    	strcpy(lname, buf); /* save their first name */
    }
    else
    {
        printf("Name too long, must be less than %d characters\n", NAMESIZ);
    }

    printf("Enter your age: "); /* ask for age */
    gets(buf); /* get response from user */
    age = atoi(buf); /* convert to a number */

    /*
     * We have all the information now, display it for the user to see
     */
    printf("Name: %s %s, age %d\n", fname, lname, age);

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
 }
