#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/*
 * This program will fill an array with random numbers
 * and then display the results.
 *
 * The user may then enter a number, and the program will
 * find the last occurance of that number in the table.
 *
 */

/* define the size of the table */
#define MAXENT 100

/* prototype for the find_last routine */
int find_last(int array[], int maxsize, int key);

main()
{
    int tbl[MAXENT];    /* the table to be filled */
    int i, key, fnd;    /* loop variable, number to find, location where found */
    char buf[BUFSIZ];

    srand(time(NULL));  /* make actual random numbers */

    for (i=0; i < MAXENT; i++)
    { /* fill the table up with random numbers */
        tbl[i] = rand() % 100;  /* with numbers from 0 to 99 */
    }

    /*
     * The table is now filled
     * Loop through the table and display each entry
     */
    for (i=0; i < MAXENT; i++)
    { /* loop through the array */
        printf("Entry %2d is %2d\n", i, tbl[i]);
        if (i%20 == 19)
        { /* screen full - pause for user */
            printf("Press ENTER to continue: ");
            getchar(); /* wait for user to press ENTER */
        }
    }

    /*
     * now loop asking the user for a number, and find the last entry
     * containing that number
     */
    while (1)
    { /* loop until done */
        printf("Enter a number, or ENTER to quit: ");
        gets(buf);
        if (buf[0] == 0) break;
        key = atoi(buf);    /* the number we are looking for */
        fnd = find_last(tbl, MAXENT, key);
        if (fnd < 0) printf("Number %d not found in table\n", key);
        else printf("Number %d last found in entry %d\n", key, fnd);
    }

    printf("Press ENTER to terminate program: "); /* display another message */
	getchar(); 						/* wait for the user to press ENTER */
}

/* the find_last routine */
int find_last(int array[], int maxsize, int key)
{
    int i, ret=-1;  /* loop variable */

    /* 
     * loop through array looking for the key
     * each time we find it, save the location in ret.
     * When we are done, the variable ret contains the last
     * occurance of that number in the array
     *
     * we initialize ret
     */
    for (i=0; i < maxsize; i++) if (array[i] == key) ret = i;
    /*
     * When we are done with the above loop, ret will contain
     * the location of the last match with 'key' that we found
     *
     * If no match was found, ret will still be -1
     */
    return ret;
}
